#include "cnasica.h"
#include "variable.h"
#include "data.h"
#include "dataget.h"
#include "label.h"
#include "parse.h"
#include "stack.h"
#include "execute.h"

#ifdef USE_OWN_STRICMP
int stricmp(char *s1, char *s2) {
	int i=0;

	while(s1[i]!=0 && s2[i]!=0) {
		if(toupper(s1[i])!=toupper(s2[i])) return 1;
		i++;
	}

	return (toupper(s1[i]) - toupper(s2[i]));
}
#endif

void mygets(char *s) {
	fgets(s,MAX_STRING,stdin);
	if(s[strlen(s)-1]=='\n') s[strlen(s)-1]=0;
}

void Usage(void) {
	printf("usage: cnasica file.bas\n");
}

int main(int argc, char **argv) {

	printf(	"Cnasica intepreter 0.1\n"
			"Written by Robert Oestling\n\n");

	if(argc!=2) {
		Usage();
		return -1;
	}

	if(StackAllocate(STACK_SIZE)==-1) {
		printf("Can not allocate memory for stack\n");
		return -1;
	}

	if(ExecuteFile(argv[1])==-1) {
		StackFree();
		return -1;
	}

	StackFree();

	return 0;
}