#include "cnasica.h"
#include "data.h"

int DataLoadFile(SData *data, char *name) {
	FILE *file;

	if((file = fopen(name,"rb")) == NULL) {
		/* Can not open file, return -1 */
		return -1;
	}

	/* Seek to the end of file */
	fseek(file,0,SEEK_END);
	/* Now the current location = file size */
	data->size = ftell(file);
	data->ptr = 0;

	if((data->data = (char*) malloc(data->size + 1)) == NULL) {
		/* Try to allocate memory for the file (and one more byte for the zero :) */
		/* If that fails, return -1 */
		return -1;
	}

	/* Seek to the beginning of the file, and load it */
	fseek(file,0,SEEK_SET);
	fread(data->data,data->size,1,file);

	/* Put a zero at the end */
	data->data[data->size] = 0;

	fclose(file);
	return 0;
}

void DataFree(SData *data) {
	free(data->data);
}
