#include "cnasica.h"
#include "dataget.h"
#include "data.h"

int is_space(char c) {
	switch(c) {
		case '\t':
		case ' ':
			return 1;
		default:
			return 0;
	};
}

int is_line_break(char c) {
	switch(c) {
		case 0x0a:
		case 0x0d:
			return 1;
		default:
			return 0;
	};
}

int is_operator(char c) {
	switch(c) {
		case '=':
		case '<':
		case '>':
			return 1;
		default:
			return 0;
	};
}

int is_ident(char c) {
	if((c>='A'&&c<='Z')||(c>='a'&&c<='z')||(c>='0'&&c<='9')||c=='_'||c=='$'||c=='.'||c=='-') return 1;
	return 0;
}

int is_digit(char c) {
	if((c>='0'&&c<='9')||c=='-') return 1;
	return 0;
}

void JumpSpace(SData *data) {
	while(is_space(data->data[data->ptr])) data->ptr++;
}

void JumpLineBreak(SData *data) {
	while(is_line_break(data->data[data->ptr])) data->ptr++;
}

void JumpToLineBreak(SData *data) {
	while(!is_line_break(data->data[data->ptr]) && data->data[data->ptr]!=0) data->ptr++;
}

int IsLast(SData *data) {
	if(data->data[data->ptr]==0) return 1;
	return 0;
}

int DataGetIdent(SData *data, char *s) {
	int i=0;

	while(is_ident(data->data[data->ptr])) s[i++] = data->data[(data->ptr)++];
	s[i]=0;

	return i;
}

int DataGetOperator(SData *data, char *s) {
	int i=0;

	while(is_operator(data->data[data->ptr])) s[i++] = data->data[(data->ptr)++];
	s[i]=0;

	return i;
}

int DataGetNumber(SData *data, char *s) {
	int i=0;

	while(is_digit(data->data[data->ptr])) s[i++] = data->data[(data->ptr)++];
	s[i]=0;

	return i;
}
