#ifndef __variable_h__
#define __variable_h__

#define	VARIABLE_INTEGER	0
#define	VARIABLE_STRING		1
#define	VARIABLE_FLOATING	2

typedef union u_variable_value UVariableValue;
typedef struct s_variable SVariable;

union u_variable_value {
	int integer;
	double floating;
	char* string;
};

struct s_variable {
	char name[MAX_IDENT];
	UVariableValue value;
	int type;
	SVariable *next;
};

int VariableCreate(SVariable **variablelist, char* name, UVariableValue *value, int type);
SVariable* VariablePointer(SVariable *variablelist, char* name);
int VariableGet(SVariable *variablelist, char *name, UVariableValue *value);
int VariableSet(SVariable *variablelist, char *name, UVariableValue *value);
int VariableGetFloat(SVariable *variable, double *x);
int VariableGetInt(SVariable *variable, int *x);
int VariableGetString(SVariable *variable, char *x);
void VariableFree(SVariable *variablelist);

#endif